// ActionScript file
import config.ApplicationConfig;

import flash.events.Event;
import flash.events.KeyboardEvent;
import flash.filesystem.File;
import flash.net.NetStream;
import flash.net.URLRequest;
import flash.utils.Dictionary;

import hello.ChatManager;
import hello.Client;
import hello.CustomEvent;
import hello.VideoRecorder;
import hello.testp;

import mx.collections.ArrayCollection;
import mx.collections.ArrayList;
import mx.collections.XMLListCollection;
import mx.controls.Alert;
import mx.controls.MenuBar;
import mx.events.MenuEvent;
import mx.managers.PopUpManager;
import mx.messaging.MessageAgent;

import spark.components.Application;
import spark.components.Window;
import spark.events.IndexChangeEvent;

public static var joinFunction:Function;
private static var appConfig:ApplicationConfig;
private var jcw:JoinChatWin;
private var genWindow:testp;
[Bindable]
private var menuBarCollection:XMLListCollection;
private var menuBarXML:XMLList=
	<>
		<menuitem label="Host" data="top">			
			<menuitem label="Select host" data="join_chat"/>
			<menuitem label="Show thumbs" data="show_thumbs"/>
			<menuitem label="Change nickname/ID" data="change_nick"/>
		</menuitem>
		<menuitem label="chat" data="top">
			<menuitem label="big size" data="big_chat"/>
			<menuitem label="small size" data="small_chat"/>
			<menuitem label="reconnect" data="reconnect_chat"/>
			<menuitem label="UserList" data="get_userlist"/>
            <menuitem label="Add bookmark" data="add_bookmark"/>
			<menuitem label="test Join private" data="join_private"/>
			<menuitem label="test Show self" data="show_self"/>
		</menuitem>
		<menuitem label="video record" data="top">
			<menuitem label="Save to file" data="save_stream"/>
			<menuitem_record label="Record/Stop" data="record"/>
			<!-- <menuitem label="Stop Record" data="stop_record"/ -->
			<menuitem_pauseresume label="Pause/Resume" data="pause_record"/>		
			<!--menuitem label="Resume" data="resume_record"/ -->
			<menuitem label="ServRecord" data="serv_record"/>			
			<!--menuitem label="ServRecord_rec" data="serv_record_rec"/-->
		</menuitem>
	
	</>;			
private var usersList:ArrayList= new ArrayList();
private var fileSaveTo:File;
private var vr:VideoRecorder=null;
private var lw:LoginWindow;
private var startRecordWhenFileSaved:Boolean=false;

private function saveData(event:Event):void 
{	
	var fileToRecord:File = event.target as File; 	
	if (!fileToRecord.exists)
	{
		//Если запись идет, а мы наджали на сохранить файл, то запись надо остановить
		if ((vr!=null)&&(vr.isRecording)){
			vr.stopRecording();
			vr=null;
		}	
		vr = new VideoRecorder(videoBox.videoObject,fileToRecord);
		vr.addEventListener(VideoRecorder.RECORD_STATE_ACTION,onRecordingState);
		//Если нажали сразу на запись а файл сохранен небыл то он его сохраняет со стартом записи
		if(startRecordWhenFileSaved){
			vr.startRecording();
			startRecordWhenFileSaved=false;
		}
	}else{
		stateRecord.text="Errror File Exist! not saved.";
		vr=null;
	}	
}
public function onRecordingState(event:CustomEvent):void {	
	switch (event.data){
		case "1":
			stateRecord.text="recording Resumed";
			break;
		case "2":
			stateRecord.text="recording Paused";
			break;
		case "3":
			stateRecord.text="recording Started";
			break;
		case "4":
			stateRecord.text="recording Stopped";
			break;
	}
}

public function onClickJoin(event:CustomEvent):void {	
	genWindow.onClickJoin(event);
	
}
public function menuHandler(evt:MenuEvent):void{
	var s:String=evt.item.@data;
	//var file:File = File.documentsDirectory;
	//var url:URLRequest = new URLRequest("file://mySampleFile.txt");
	//var loader:URLLoader = new URLLoader();
	//loader.addEventListener(Event.COMPLETE,onText);
	//loader.load(url);		
		
	switch (s) {		
		case "big_chat":
			videoBox.width=640;
			videoBox.height=480;
			this.width=820;
			this.height=720;
			break;
		case "small_chat":
			videoBox.width=320;
			videoBox.height=240;
			this.width=500;
			this.height=480;
			break;	
		case "record":
			if ((vr!=null)&&(vr.isRecording)){				
				vr.stopRecording();
				vr=null;
			}else{
				if(vr==null){
					startRecordWhenFileSaved=true
					fileSaveTo.browseForSave("Save Stream to");					
					fileSaveTo.addEventListener(Event.SELECT,saveData);					
				}else{
					vr.startRecording();
				}
			}			
			break;
		/*		case "stop_record":
			vr.stopRecording();
			break;
		case "resume_record":
			vr.resumeRecording();
			break;			*/
		case "pause_record":
			vr.pauseResumeRecording();
			break;
		case "join_chat":
			jcw=new JoinChatWin();						
			jcw.addEventListener(JoinChatWin.ON_CLICK_JOIN,onClickJoin);
			jcw.open();			
			break;
		case "save_stream":
			startRecordWhenFileSaved=false;
			fileSaveTo.browseForSave("Save Stream to");			
			fileSaveTo.addEventListener(Event.SELECT,saveData);
			break;
		case "reconnect_chat":
			genWindow.connect();
			break;
		case "show_thumbs":
			var tsw:ThumdSelectWin=new ThumdSelectWin();
			tsw.open();
			break;
		case "change_nick":
			showLoginWin();
			break;
		case "get_userlist":
			//genWindow.strm.seek(-120);
			//genWindow.cm.so[genWindow.guestName]=0;
			//genWindow.cm.so.setProperty(genWindow.guestName," ");
			genWindow.cm.GetUserList();
			break;
		case "serv_record":
			genWindow.recordToServer();
			break;
		/*case "serv_record_rec":
			genWindow.recordMovie();
			break;*/
		case "add_bookmark":
			appConfig.addBookmark("0",genWindow.hostID,genWindow.hostName,"","","","5","");
			break;
		case "show_self":
			genWindow.sendOnVideoStarted();
			break;
		case "join_private":
			genWindow.JoinPrivate();
	}
}	

public function onAcceptEnter(event:CustomEvent):void{
	stateChat.text="Host state: Join free chat";
}

public function onDisconnectServer(event:CustomEvent):void{
	stateChat.text="Host state: Disconnect from server!!";
}
public function onUpdateOpenedHost(event:CustomEvent):void{
	 this.hostnick.text="Host nickname: "+event.data.hostnick;
}
public function onRoomReject(event:CustomEvent):void{
	 var ss:String=event.data.toString();
	 stateChat.text="Host state: "
	 switch (ss){		 
		 case "1":stateChat.text+="user rejected";break;
		 case "2":stateChat.text+="connection lost";break;
		 case "3":stateChat.text+="host close room";break;
		 case "4":stateChat.text+="appshutdown"; break;
		 case "5":stateChat.text+="leave room on host side"; break;
		 case "6": stateChat.text+="join private";	break;		 
		 case "7": stateChat.text+="disconect user";break;
		 case "8": stateChat.text+="tmpuser rejected";break;
		 case "11": stateChat.text+="disconnected";	break;		 
		 default: stateChat.text+=ss;
	 }
}
public function onLoginwinLoginClick(event:CustomEvent):void{
	appConfig.username={login:event.data.guestname,userID:event.data.guestid};
	genWindow.setGuestNameUID(event.data.guestname,event.data.guestid);
	chatNickname.text=event.data.guestname;
	if (genWindow.nc!=null){
		if (genWindow.nc.connected){
		  genWindow.connect();
		}
	}
	//this.visible=true;
}

protected function chatInput_keyDownHandler(event:KeyboardEvent):void
{
	if ((event.keyCode==13)&&(chatInput.text.length>0)){
		genWindow.cm.SendMessage(false,chatNickname.text,chatInput.text);
		chatInput.text="";
	}
}
public function showLoginWin():void{
	lw = new LoginWindow();
	var ob:Object =appConfig.username;	
	lw.addEventListener(LoginWindow.LOGIN_WIN_CLICK,onLoginwinLoginClick);
	lw.alwaysInFront=true;
	lw.open();
	lw.guestNameInput.text=ob.login;
	lw.guestIDInput.text=ob.userID;
}

public function addChatMessage(msg:Object):void{
	trace("---------MSG--------")
	chatText.text+=((msg.privat)?"[private]":"")+msg.uname+":"+msg.msg+'\n';
	chatText.scrollToRange(chatText.text.length);	
}

public function onChatMessage(event:CustomEvent):void{
	addChatMessage(event.data);
}

public function onChatHistory(event:CustomEvent):void{
	chatText.text+="<< CHAT HISTORY >>\n";
	for each (var value:Object in event.data){
		addChatMessage(value);
	}
	chatText.text+="<< ----- >>\n";
}

public function onConnect(event:CustomEvent):void{
	usersList.removeAll();
}
public function onChangeUsers(event:CustomEvent):void{
	switch (event.data.code){		
		case "delete":
			//userList.cla
			//usersList.			
			usersList.removeItem(event.data.name);
			trace("leave: "+event.data.name);
			break;
		case "change":
			trace("join: "+event.data.name);
			usersList.addItem(event.data.name);
			break;
		}		
}

public function onTestServer(event:CustomEvent):void{	
	stateRecord.text="test server: "+event.data;
}

protected function closingChat(event:Event):void
{
	// TODO Auto-generated method stub
	appConfig.saveSettingsToFile();
}
public static function getConfig():ApplicationConfig{
	return appConfig;
}



protected function userList_changeHandler(event:IndexChangeEvent):void
{
	var item:String = event.currentTarget.selectedItem;
	var gv:GuestVideoWin=new GuestVideoWin;
	gv.title=item;
	gv.open();		
	trace("rcv guest strem START");	
	var strm:NetStream=new NetStream(genWindow.nc);
	gv.GuestVideo.videoObject.attachNetStream(strm);
	trace(item.toLowerCase());	
	strm.play(item.toLowerCase());
	strm.receiveAudio(true);
	
	strm.client=genWindow.cm;
	/// cm.setNC(nc,this);
	/// strm.client=cm;	

	// TODO Auto-generated method stub
}

protected function ChatRequestError(event:CustomEvent):void{
//	Code:"+event.data[0]+" Credit:"+event.data[1]+"
	chatText.text+="When join private ChatRequestError, \n";
	var s:String="============\n";
	for (var a:Object in event.data){
		s+="key:"+a+" val:"+event.data[a]+"\n";
	}
	s+="============\n";
	chatText.text+=s;
}

public function initData():void{
	joinFunction=onClickJoin;
	fileSaveTo= new File();	
	appConfig =ApplicationConfig.getInstance();	
	
	menuBarCollection=new XMLListCollection(menuBarXML);
	this.width=500;
	this.height=480;
	genWindow=new testp(videoBox,chatText);	
	genWindow.cc.addEventListener(Client.DO_ACCEPT_ENTER,onAcceptEnter);
	genWindow.cc.addEventListener(Client.DO_ROOM_REJECT,onRoomReject);
	genWindow.cc.addEventListener(Client.DO_CHAT_HISTORY,onChatHistory);
	genWindow.addEventListener(testp.DISCONNECT_FROM_SERVER,onDisconnectServer);
	genWindow.addEventListener(testp.UPDATE_OPENNED_HOST,onUpdateOpenedHost);	
	genWindow.cm.addEventListener(ChatManager.ON_MESSAGE,onChatMessage);
	genWindow.cc.addEventListener(ChatManager.ON_MESSAGE,onChatMessage);//!!
	genWindow.cc.addEventListener(Client.CHATREQUESTERROR,ChatRequestError);//!!
	genWindow.cm.addEventListener(ChatManager.ON_CHANGE_USERS,onChangeUsers);
	genWindow.addEventListener(testp.ON_CONNECT,onConnect);
	genWindow.addEventListener(testp.ON_TEST_SERVER,onTestServer);
	
	showLoginWin();
	userList.dataProvider=usersList;
	
	//trace(File.createTempFile().name);
	//lw.activate();	
	//PopUpManager.addPopUp(lw,this,true);
	//PopUpManager.centerPopUp(lw);
	//this.visible=false;
	
	//trace("==XML==");
	//var results:XMLList =menuBarXML.menuitem.(@data=="top");
	//menuBarXML.replace("label","hello");
	/*for each(var a:XML in menuBarXML.descendants("menuitem_record") ){
		trace("==");
		a.replace("label","hello");
		trace(a.toXMLString());
	}*/
	//trace("==   ==");
}
