package config
{
	import flash.events.EventDispatcher;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	import flash.xml.XMLNodeType;
	
	import hello.CustomEvent;
	
	public class ApplicationConfig extends EventDispatcher
	{
		public static var ON_UPDATE_BOOKMARK:String="OnUpdateBookmark";
		private static var appConfig:ApplicationConfig=null; 
		public var confXML:XMLDocument;
		private static var ConfigName:String="chatConfig.xml";
		private static var LoginSectionName:String="login";
		private static var BookmarksSectionName:String="bookmarks";
		public var bookmarkNode:XMLNode;
		public var loginNode:XMLNode;
		
		public function saveSettingsToFile():void{
			resetAdvInfo();
			var f:File = File.desktopDirectory.resolvePath(ConfigName);
			var fs:FileStream= new FileStream();
			fs.open(f,FileMode.WRITE);
			fs.writeUTFBytes(confXML.toString());
			fs.close();
		}
		//---- Поиск секции в XML файле ----
		protected function getSectionNode(nodeName:String):XMLNode{
			var fn:XMLNode=confXML.firstChild;			
			var sNodes:XMLNode=fn.firstChild;
			trace(sNodes.nodeName);
			while ((sNodes!=null)&&(sNodes.nodeName!=nodeName)){
				sNodes=sNodes.nextSibling;
			}
			return sNodes;
		}	
		//---- Запоминание имени пользователя и пароля ----
		public function set username(val:Object):void{
			if(loginNode!=null){
				loginNode.attributes=val;
			}		
		}
		
		public function get username():Object{
			if(loginNode!=null){
				return loginNode.attributes;
			}
			return {login:"",userID:""};
		}
		//---<>---
		//--- Удаляем закладки ---
		public function removeBookmark(nickname:String):void{
			if (confXML.idMap[nickname]){
				confXML.idMap[nickname].removeNode();
				delete confXML.idMap[nickname];
				dispatchEvent(new CustomEvent(ApplicationConfig.ON_UPDATE_BOOKMARK,{nickname:nickname}));
			}
		}
		
		public function upgateBookmark(xn1:XMLNode):void {
			var ob:Object=xn1.attributes;
			var xn:XMLNode= confXML.idMap[ob.NickName];
			if(xn){
				xn.attributes=ob;
				xn.attributes.id=ob.NickName;
				//Теперь блин появился PropList внутри, и нужно как-то и его сохранять и обновлять в закладках.... МараКуЙя!
				var xn4:XMLNode=xn1.firstChild;
				if ((xn4!=null)&&(xn4.nodeName=="PropList")) {
					var xn2:XMLNode=xn.firstChild;
					while ((xn2!=null)&&(xn2.nodeName!="PropList")){
						xn2=xn2.nextSibling;
					}
				
					if((xn2!=null)&&(xn2.nodeName=="PropList")){
						xn2.attributes.cdnserver=xn4.attributes.cdnserver;
					}else{
						var xn3:XMLNode=new XMLNode(XMLNodeType.ELEMENT_NODE,"PropList"); // confXML.createElement('PropList');
						xn3.attributes.cdnserver=xn4.attributes.cdnserver;
						xn.appendChild(xn3);
					}
				}	
			}
		}
		
		//--- Добавление закладки---
		public function addBookmark(roomid:String,hostid:String,nickname:String,mainimg:String,ServerIDF:String,GCountF:String, RateF:String, cdnserver:String):void{						
			if(bookmarkNode!=null){
				var bm:XMLNode= new XMLNode(XMLNodeType.ELEMENT_NODE,"Data");
				confXML.idMap[nickname]=bm;
				bm.attributes={id:nickname,RoomID:roomid,BighostID:String(Number(hostid)*12345),NickName:nickname,MainImg:mainimg,WorkingServer:ServerIDF,GCount:GCountF,HostRating:RateF};
				var propList:XMLNode=new XMLNode(XMLNodeType.ELEMENT_NODE,"PropList");
				propList.attributes.cdnserver=cdnserver;
				bm.appendChild(propList);
				bookmarkNode.appendChild(bm);
				dispatchEvent(new CustomEvent(ApplicationConfig.ON_UPDATE_BOOKMARK,{nickname:nickname}));
			}
		}
		//---<>---
		
		public function loadSettingsFromFile():void{
			confXML=new XMLDocument;
			try{
				var f:File = File.desktopDirectory.resolvePath(ConfigName);
				var fs:FileStream= new FileStream();
				fs.open(f,FileMode.READ);
				confXML.parseXML(fs.readUTFBytes(fs.bytesAvailable));
				fs.close();
				bookmarkNode=getSectionNode(BookmarksSectionName);
				loginNode=getSectionNode(LoginSectionName);
			} catch(err:Error){
				var cc:XMLNode=new XMLNode(XMLNodeType.ELEMENT_NODE,"chat_config");
				loginNode=new XMLNode(XMLNodeType.ELEMENT_NODE,LoginSectionName);
				loginNode.attributes.login="nickolay123";
				loginNode.attributes.userID="26575348";				
				cc.appendChild(loginNode);
				bookmarkNode=new XMLNode(XMLNodeType.ELEMENT_NODE,BookmarksSectionName);
				cc.appendChild(bookmarkNode);
				confXML.appendChild(cc);							
			}
		}
		//Удаление дополнительных данных, которые не должны храниться в файле
		public function resetAdvInfo():void{
		   var xn:XMLNode=bookmarkNode.firstChild;
		   while (xn){
			   
//			   <Data GCount="33" Sort="12920054009893" HostRating="5" 
			   //WorkingServer="fly17" 
			   xn.attributes.WorkingServer="";
			   xn.attributes.GCount="";
			   xn.attributes.FreeSupported="";
//			   MainImg="http://i4.imlive.com/imagesrv/imp_getimage?is=IMLFOH&amp;qu=77&amp;wm=108x90&amp;fn=0336/374336/374336O1265021795.jpg"
//			   FreeSupported="0" GWServer="fly17" RoomID="10" NickName="RussEliza" BighostID="4621177920" />			   
			   xn=xn.nextSibling;
		   }
		}
		public static function getInstance():ApplicationConfig{
		  	if (appConfig==null){
				appConfig=new ApplicationConfig();
			}
			return appConfig;
		}
		
		public function ApplicationConfig()
		{
			loadSettingsFromFile();
		}
	}
}